/*
  automaton.c
*/

#include <stdio.h>
#include "automaton.h"

/*crer un automate vide*/
void automaton__empty (automaton *a )
{
  state q;    /*state et letter correspondent en fait  des entiers, on aurait pu mettre "int q,l;" */
  letter l;

  a->q0 = UNDEFINED_STATE;
  stateset__empty(&(a->F));

  for(q=0;q<MAX_STATE;q++)
    {
      for(l=0;l<MAX_LETTER;l++)
	{
	  a->delta[q][l]=UNDEFINED_STATE;
	}
    }
}


/*ajouter un tat initial*/
void automaton__set_initial (automaton * , state s)
{
  a->q0=s;
}


/*ajouter un tat final (s'il tait final, il ne l'est plus)*/
void automaton__toggle_final_state (automaton * , state s)
{
  if (stateset__belongs_to(&(a->F),s))
    stateset__remove_state(&(a->F),s);
  else stateset__add_state(&(a->F),s);
}


/*ajouter une transition*/
void automaton__add_transition (automaton *a , state s1, letter l, state s2)
{
  a->delta[s1][l]=[s2];
}


/*passer la transition*/
state automaton__apply_transition (automaton *a , state s, letter l)
{
  return a->delta[s][l];
}


/*tester si un tat est final*/
int automaton__is_final_state (automaton *a , state s)
{
  return stateset__belongs_to(&(a->F),s);
}
