/*
  automat.h
*/

#ifndef _AUTOMATON_H_
#define _AUTOMATON_H_   1

#include "state.h"
#include "stateset.h"
#include "letter.h"

/* Transition function */
typedef state trans_fun[MAX_STATE][MAX_LETTER];


/* Automaton */
  struct s_automaton
  {
    state q0;
    stateset F;
    trans_fun delta;

    /*on peut rajouter 'stateset Q;' et 'int S[];' pour reprsenter Sigma mais ils ne servent  rien car on se dplace en suivant les tats et les transitions, on n'a pas besoin de connaitre l'ensemble des tats et l'ensemble des transitions*/
  };
typedef struct s_automaton automaton; /*automaton est un alias pour la structure de type automaton*/

/* Implementation */

void automaton__empty (automaton * );
void automaton__set_initial (automaton * , state);
void automaton__toggle_final_state (automaton * , state);
void automaton__add_transition (automaton * , state, letter, state);
state automaton__apply_transition (automaton * , state, letter);
int automaton__is_final_state (automaton * , state);

#endif /* _AUTOMATON_H_ */
