/*
  uautomat.h
*/

#ifndef _UAUTOMATON_H_
#define _UAUTOMATON_H_   1

#include "state.h"
#include "stateset.h"
#include "letter.h"

/* Transition function */
typedef stateset utrans_fun[MAX_STATE][MAX_LETTER];


/* UAutomaton */
struct s_uautomaton
{
  state q0;
  stateset F;
  utrans_fun delta;
};

typedef struct s_uautomaton uautomaton; 

/* Implementation */

void uautomaton__empty (uautomaton * );
void uautomaton__set_initial (uautomaton * , state);
void uautomaton__toggle_final_state (uautomaton * , state);
void uautomaton__add_transition (uautomaton * , state, letter, state);
void uautomaton__apply_transition (uautomaton * , stateset *, state, letter);
int uautomaton__contains_final_state(uautomaton * , stateset *);
int uautomaton__apply_set_transition(uautomaton * , stateset * , letter, stateset *);
void uautomaton__epsilon_cloture(uautomaton *u, stateset *q, stateset *clq);

#endif /* _UAUTOMATON_H_ */
